from org.codehaus.jettison.json import JSONObject, JSONArray
import sys;
from utilities import Util
from Property import Property

__name_att__ = None;

def _export(objid, parentrespath, name = ""):
  Util.pushPathElement('DPClonableDeviceSettings')


  if parentrespath == "/":
    parentrespath = "";
  respath = "%(parentrespath)s/%(name)s" % { 'parentrespath':parentrespath, 'name':name }
  if not respath.startswith("/"):
    respath = "/" + respath;

  exportedObject = JSONObject();
  exportedObject.put("name", name);
  exportedObject.put("path", respath);
  exportedObject.put("teamMappings", JSONArray());
  exportedObject.put("inheritTeam", "true");
  exportedObject.put("description", "Discovered WebSphereDPClonableDeviceSettings");
  exportedObject.put("roleName", "WebSphereDPClonableDeviceSettings");

  roleProperties = JSONObject();

  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.dpclonabledevicesettings.highestversion", objid, "highestVersion","DPClonableDeviceSettings");
  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.dpclonabledevicesettings.name", objid, "name","DPClonableDeviceSettings");
  exportedObject.put("roleProperties", roleProperties);
  result = { 'object': exportedObject, 'respath':respath }
  extraObjects = [];
  typeFolders = {};
  extraObjects = Property.exportProperties(objid, respath, extraObjects, typeFolders, 'properties',"DPClonableDeviceSettings");
  if len(extraObjects) != 0:
    result['extraObjects'] = extraObjects;
  Util.popPathElement('DPClonableDeviceSettings');
  return result;



def create(parentid, jsonobject):
  Util.pushPathElement('DPClonableDeviceSettings')
  if not jsonobject.has("roleProperties"):
    raise Exception("DPClonableDeviceSettings resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  properties = [];
  Util.addIfNotNone(properties, "highestVersion", roleProperties.optString("websphere.dpclonabledevicesettings.highestversion", None));
  Util.addIfNotNone(properties, "name", roleProperties.optString("websphere.dpclonabledevicesettings.name", None));
  print "Creating DPClonableDeviceSettings with attributes";
  for prop in properties:
    print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };
  objid = Util.create("DPClonableDeviceSettings", parentid, properties);
  if jsonobject.has('children'):
    for curjsonobject in Util.getHighestChildrenWithRole(jsonobject.getJSONArray('children')):
      currole = curjsonobject.getString("roleName");
      propertyObject = Property.createObjIfRole(objid, curjsonobject, currole);
  Util.popPathElement('DPClonableDeviceSettings');

def update(objid,jsonobject):
  Util.pushPathElement('DPClonableDeviceSettings')
  if not jsonobject.has("roleProperties"):
    raise Exception("DPClonableDeviceSettings resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  atts = [];
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.dpclonabledevicesettings.highestversion", None), "highestVersion","DPClonableDeviceSettings");
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.dpclonabledevicesettings.name", None), "name","DPClonableDeviceSettings");
  if len(atts) != 0:
    print "Modifying DPClonableDeviceSettings with attributes:"
    for prop in atts:
      print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };

    Util.modify(objid, atts);
  else:   
    print "DPClonableDeviceSettings configuration up to date.";

  Property.removeProperties(objid, 'properties',"DPClonableDeviceSettings");

  if jsonobject.has('children'):
    for curjsonobject in Util.getHighestChildrenWithRole(jsonobject.getJSONArray('children')):
      currole = curjsonobject.getString("roleName");
      propertyObject = Property.createObjIfRole(objid, curjsonobject, currole);
  Util.popPathElement('DPClonableDeviceSettings');
